//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers   2
#property indicator_color1    DodgerBlue
#property indicator_color2    Magenta

//
//
//
//

extern string TimeFrame               = "Current time frame";
extern int    T3Period                = 20;
extern int    T3Price                 = PRICE_CLOSE;
extern double T3Hot                   = 0.7;
extern bool   T3Original              = false;
extern int    StochasticPeriod        = 50;
extern int    StochasticSignalPeriod  = 10;
extern bool   ArrowOnLast             = false;
extern int    ArrowSize               = 1;


extern bool   alertsOn                = false;
extern bool   alertsOnCurrent         = false;
extern bool   alertsMessage           = true;
extern bool   alertsSound             = true;
extern bool   alertsEmail             = false;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double sigUp[];   
double sigDn[];   
double trend[];


string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;
double Main0,Main1,Sign0,Sign1;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,sigUp);   SetIndexStyle(0,DRAW_ARROW,ArrowSize); SetIndexArrow(0, 233); SetIndexLabel(0,"Up");
   SetIndexBuffer(1,sigDn);   SetIndexStyle(1,DRAW_ARROW,ArrowSize); SetIndexArrow(1, 234); SetIndexLabel(1,"Dn");
   SetIndexBuffer(2,buffer1); SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(3,buffer2); SetIndexStyle(3,DRAW_NONE);
   SetIndexBuffer(4,buffer3); SetIndexStyle(4,DRAW_NONE);
   SetIndexBuffer(5,trend);   SetIndexStyle(5,DRAW_NONE);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //

//      IndicatorShortName(timeFrameToString(timeFrame)+" "+indicatorFileName+" "+T3Period+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { buffer1[0] = MathMin(limit+1,Bars-1); return(0); }
   
   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      double alpha = 2.0 / (1.0 + StochasticSignalPeriod);
      for(int i=limit; i>=0; i--)
      {
         buffer3[i] = iT3(iMA(NULL,0,1,0,MODE_SMA,T3Price,i),T3Period,T3Hot,T3Original,i);
      
         //
         //
         //
         //
         // 
      
         double hi = buffer3[ArrayMaximum(buffer3,StochasticPeriod,i)];
         double lo = buffer3[ArrayMinimum(buffer3,StochasticPeriod,i)];
         if (hi != lo)
               buffer1[i] = 100*(buffer3[i]-lo)/(hi-lo);
         else  buffer1[i] = 0.00;
         if (StochasticSignalPeriod>1)
               buffer2[i] = buffer2[i+1] + alpha*(buffer1[i]-buffer2[i+1]);
         
         sigUp[i] = EMPTY_VALUE;
         sigDn[i] = EMPTY_VALUE;
         trend[i] = trend[i+1];
            if (buffer1[i] > buffer2[i]) trend[i] = 1;
            if (buffer1[i] < buffer2[i]) trend[i] =-1;
            if (trend[i] != trend[i+1])
            if (trend[i]==1) 
                  sigUp[i] = Low[i] -iATR(NULL,0,10,i)/2.0; 
            else  sigDn[i] = High[i]+iATR(NULL,0,10,i)/2.0; 
      } 
   manageAlerts();              
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   int displace = 1; if (ArrowOnLast) displace=-1;
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      int x = iBarShift(NULL,timeFrame,Time[i+displace]); 
         buffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3Period,T3Price,T3Hot,T3Original,StochasticPeriod,StochasticSignalPeriod,0,y);
         buffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3Period,T3Price,T3Hot,T3Original,StochasticPeriod,StochasticSignalPeriod,1,y);
         trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3Period,T3Price,T3Hot,T3Original,StochasticPeriod,StochasticSignalPeriod,5,y);
         sigUp[i] = EMPTY_VALUE;
         sigDn[i] = EMPTY_VALUE;
          if (x!=y)
          {
            int z = iBarShift(NULL,0,iTime(NULL,timeFrame,y+1));
            if (trend[i] != trend[z])
               if (trend[i]==1) 
                     sigUp[i] = Low[i] -iATR(NULL,0,10,i)/2.0; 
               else  sigDn[i] = High[i]+iATR(NULL,0,10,i)/2.0; 
          }          
   } 
   manageAlerts();
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][6];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"Up");
         if (trend[whichBar] == -1) doAlert(whichBar,"Dn");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Stoch of T3 ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Stoch of T3"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------